function [T,Y] = rk4(f,tspan,Y0)
    global deltat;
    T = tspan(1):deltat:tspan(2);
    Y(1,:) = Y0;
    for i=1:length(T)-1
        k1 = deltat * f(T(i), Y(i,:)');
        k2 = deltat * f(T(i) + 1/2 * deltat, (Y(i,:) + (1/2 * k1)')');
        k3 = deltat * f(T(i) + 1/2 * deltat, (Y(i,:) + (1/2 * k2)')');
        k4 = deltat * f(T(i) + deltat, (Y(i,:) + (k3)')');
        Y(i+1,:) = Y(i,:) + 1/6 * k1' + 1/3 * k2' + 1/3 * k3' + 1/6 * k4';
        if mod(i,5) == 0
            fprintf('At step #%d\n',i);
        end
    end
end